import numpy as np
from matplotlib import pyplot as plt
from PIL import Image
import sys

sys.path.insert(0, '../../algorithms/distance/')

from rmsdiff import rmsdiff

IMAGE_SIZE = 64

def randomImage(scale):
    # Is `np.clip` necessary? See `toPilImage`.
    return np.random.normal(loc = 0, scale = scale, size = (IMAGE_SIZE, IMAGE_SIZE))

prnu = randomImage(scale = 1)

images = [randomImage(scale = 10) + prnu for _ in range(10)]

def toPilImage(npArray):
    nonNegativeArray = npArray - np.min(npArray)
    nonNegativeArray = np.round(255 * nonNegativeArray / np.max(nonNegativeArray))
    return Image.fromarray(np.uint8(nonNegativeArray))

toPilImage(prnu).show()

for image in images:
    print(rmsdiff(image, prnu))
    print(rmsdiff(contextAdaptiveInterpolator(image), prnu))